import '@host';
import './social-auth-buttons.scss';

import { HotReload }            from '../../../scripts/decorators/hot-reload';
import { Component }            from '../../../scripts/decorators/component';
import { View }                 from '../../../scripts/decorators/view';

@HotReload(module)

@Component({
  selector: 'social-auth-buttons',
  bind: {
    facebookClick: '&',
    googleClick: '&'
  }
})

@View({
  template: require('./social-auth-buttons.html')
})

/**
 * @class SocialAuthButtons
 */
export class SocialAuthButtons {

  facebookClick: any;
  googleClick: any;

  buttonClick(type: string) {
    if (type === 'facebook') {
      this.facebookClick();
    } else {
      this.googleClick();
    }
  }
}
