import { Config } from '../decorators/config';
import { inject } from '../decorators/inject';

@Config

/**
 * @class IonicConfigs
 * @config
 * @description set up ionic configs
 */
export class FormlyConfigs {
  @inject
  private $ionicConfigProvider: any;

  constructor() {
    this.setConfigs();
  }

  /**
   * Set ionic configs
   */
  setConfigs() {
    const config = this.$ionicConfigProvider;

    // Don't use JS scrolling, it is jittery and not smooth
    // feeling on any device. The fallback (using native scrolling)
    // is much better feeling
    config.scrolling.jsScrolling(false);
  }
}
