import { Config } from '../decorators/config';
import { inject } from '../decorators/inject';

@Config

/**
 * @class LocationConfigs
 * @config
 * @description set up angualr location configs
 */
export class LocationConfigs {
  @inject
  $locationProvider: angular.ILocationProvider;

  constructor() {
    this.setConfigs();
  }

  /**
   * Set location configs
   */
  setConfigs() {
    const html5Enabled = !(typeof(ionic) !== 'undefined' && (ionic.Platform.isAndroid() || ionic.Platform.isIOS()));

    this.$locationProvider.html5Mode({
      requireBase: false,
      enabled: html5Enabled
    });
  }
}
