import { Constant } from '../../decorators/constant';

@Constant('stringUtils', true)

/**
 * @class StringUtils
 *
 * Utils for strings
 */
export class StringUtils {
  humanize(str = '') {
    // https://github.com/epeli/underscore.string/blob/master/underscored.js
    // https://github.com/epeli/underscore.string/blob/master/humanize.js
    const underscored = _.trim(str)
      .replace(/([a-z\d])([A-Z]+)/g, '$1_$2')
      .replace(/[-\s]+/g, '_')
      .toLowerCase()
      .replace(/_id$/, '')
      .replace(/_/g, ' ');

    const humanized = _.capitalize(_.trim(underscored))
      // replace non word characters with spaces
      .replace(/[\W_]+/g, ' ')
      // split by spaces
      .split(/\s+/)
      // capitalize each word
      .map((item) => {
        return _.capitalize(item)
      })
      // combine all words back to one string
      .join(' ');

  return humanized;
 }
}
