/**
 * @decorator Constant
 * @description create and set angular constants
 * @param {string} name           name of constant to set
 * @param {string} createInstance create an instance of this class and set
 * that as the config value
 * @type {Function}
 * @example
 * ```ts
 * @Constant('Router')
 * export class Router {
 *   // ...
 * }
 * ```
 */
export const Constant = (name: string, createInstance = false) => {
  const decorator = (target: any) => {
    if (createInstance) {
      target = new target();
    }

    angular
      // TODO: get from module name config
      .module('app')
      .constant(name, target);
  };

  return decorator;
};
