import { Directive } from '../decorators/directive';

@Directive('editJsonText')

/**
 * Allows editing of javascript objects as text
 */
export class EditJsonTextDirective implements angular.IDirective {
  restrict = 'A';
  require = 'ngModel';

  link(scope: ng.IScope, element: ng.IAugmentedJQuery, attr: ng.IAttributes, ngModel: ng.INgModelController) {
    ngModel.$parsers.push((input: string) => {
      return JSON.parse(input);
    });

    ngModel.$formatters.push((data: any) => {
      // TODO: configurable indentation
      return JSON.stringify(data, null, 2);
    });
  }
}
