import { Service } from '../decorators/service';
import { inject }  from '../decorators/inject';

// TODO: make each component do this instead
@Service('screen')
export class Screen {
  @inject
  $rootScope: angular.IRootScopeService;

  @inject
  $window: angular.IWindowService;

  sm: boolean;
  md: boolean;
  lg: boolean;

  small: boolean;
  medium: boolean;
  large: boolean;

  size: string;

  constructor() {
    angular
      .element(this.$window)
      .on('resize', () => {
        this.update();
        // TODO: safe $apply()
      });
  }

  private sizes = {
    sm: 300,
    md: 769,
    lg: 992
  };

  update() {
    const width = this.$window.innerWidth;
    const { sm, md } = this.sizes;

    if (width <= sm) {
      this.size = 'small';
    } else if (width > sm && width < md) {
      this.size = 'medium';
    } else {
      this.size = 'large';
    }

    this.sm = this.small = this.size === 'small';
    this.md = this.medium = this.size === 'medium';
    this.lg = this.large = this.size === 'large';
  }
}
