export interface IMobile {
  url: string;
}

export interface IDefault {
  url: string;
}

export interface IFeatured {
  url: string;
}

export interface IMobile2x {
  url: string;
}

export interface IFeatured2x {
  url: string;
}

export interface IDefault2x {
  url: string;
}

export interface ISizes {
  mobile: IMobile;
  default: IDefault;
  featured: IFeatured;
  'mobile@2x': IMobile2x;
  'featured@2x': IFeatured2x;
  'default@2x': IDefault2x;
}

export interface ILogo {
  sizes: ISizes;
}

export interface IRetailer {
  id: string;
  name: string;
  logo: ILogo;
  userId: number;
  userHandle: string;
  userImage: string;
  urlIdentifier: string;
  favIcon: string;
  effectiveContentLocale: string;
  handle: string;
}

export interface IMobile2 {
  url: string;
}

export interface IDefault2 {
  url: string;
}

export interface IFeatured2 {
  url: string;
}

export interface IMobile2x2 {
  url: string;
}

export interface IFeatured2x2 {
  url: string;
}

export interface IDefault2x2 {
  url: string;
}

export interface ISizes2 {
  mobile: IMobile2;
  default: IDefault2;
  featured: IFeatured2;
  'mobile@2x': IMobile2x2;
  'featured@2x': IFeatured2x2;
  'default@2x': IDefault2x2;
}

export interface ILogo2 {
  sizes: ISizes2;
}

export interface IBrand {
  id: string;
  name: string;
  logo: ILogo2;
  userId: number;
  userHandle: string;
  userImage: string;
  urlIdentifier: string;
}

export interface ISmall {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface IXLarge {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface IMedium {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface ILarge {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface IPhoneSmall {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface IBest {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface IOriginal {
  sizeName: string;
  url: string;
  actualWidth: number;
  actualHeight: number;
}

export interface IPhone {
  sizeName: string;
  url: string;
  width: number;
  height: number;
  actualWidth: number;
  actualHeight: number;
}

export interface ISizes3 {
  Small: ISmall;
  XLarge: IXLarge;
  Medium: IMedium;
  Large: ILarge;
  IPhoneSmall: IPhoneSmall;
  Best: IBest;
  Original: IOriginal;
  IPhone: IPhone;
}

export interface Image {
  sizes: ISizes3;
  id: string;
}

export interface ICategory {
  numId: number;
  id: string;
  name: string;
  shortName: string;
  localizedId: string;
}

export interface IMobile3 {
  url: string;
}

export interface IDefault3 {
  url: string;
}

export interface IFeatured3 {
  url: string;
}

export interface IMobile2x3 {
  url: string;
}

export interface IFeatured2x3 {
  url: string;
}

export interface IDefault2x3 {
  url: string;
}

export interface ISizes4 {
  mobile: IMobile3;
  default: IDefault3;
  featured: IFeatured3;
  'mobile@2x': IMobile2x3;
  'featured@2x': IFeatured2x3;
  'default@2x': IDefault2x3;
}

export interface ILogo3 {
  sizes: ISizes4;
}

export interface IRetailer2 {
  id: string;
  name: string;
  logo: ILogo3;
  userId: number;
  userHandle: string;
  userImage: string;
  urlIdentifier: string;
  favIcon: string;
  effectiveContentLocale: string;
  handle: string;
  deeplinkSupport: boolean;
  hostDomain: string;
}

export interface IStartDate {
  date: string;
  timestamp: number;
  friendly: string;
}

export interface IEndDate {
  date: string;
  timestamp: number;
  friendly: string;
}

export interface IPromotionalDeal {
  id: number;
  type: string;
  typeLabel: string;
  title: string;
  shortTitle: string;
  retailer: IRetailer2;
  startDate: IStartDate;
  endDate: IEndDate;
}

export interface IProduct {
  id: number;
  name: string;
  brandedName: string;
  unbrandedName: string;
  currency: string;
  price: number;
  priceLabel: string;
  inStock: boolean;
  retailer: IRetailer;
  brand: IBrand;
  locale: string;
  description: string;
  clickUrl: string;
  pageUrl: string;
  urlIdentifier: string;
  image: Image;
  alternateImages: any[];
  colors: any[];
  sizes: any[];
  categories: ICategory[];
  extractDate: string;
  badges: any[];
  promotionalDeal: IPromotionalDeal;
  favoriteCount: number;
  commentCount: number;
  hasFavorite: boolean;
  seeMoreLabel: string;
  seeMoreUrl: string;
  preOwned: boolean;
  rental: boolean;
}
