var gulp = require('gulp');
var SSBuild = require('./');
var config = require('@ssjs/shopstyle-node-config');
var runSequence = require('run-sequence');
var argv = require('yargs').argv;

module.exports = new SSBuild(config).gulp(gulp);

// TODO: publish task

// TODO: clean too if NODE_ENV isn't development
gulp.task('build', function (cb) {
  var tasks;
  if (argv.install === false) {
    tasks = [];
  } else {
    tasks = ['install'];
  }

  tasks = tasks.concat([
    'tsd:link',
    'tsc',
    'typings:bundle',
    'copy:common:assets'
  ]);

  if (process.env.NODE_ENV === 'production' || process.env.NODE_ENV === 'qa') {
    tasks.unshift('clean');
  }
  tasks.push(cb);
  runSequence.apply(null, tasks);
});

// TODO: lint too
gulp.task('watch', ['build'], function () {
  gulp
    .watch([
      '{client,server,common}/**/*.ts',
      '{package,bower,tsd,tsconfig}.json'
    ], function (cb) {
      runSequence('tsc', 'typings:bundle');
    });
  gulp
    .watch([
      'client/**/*',
      '!client/**/*.{ts,js}'
    ], function (cb) {
      runSequence('copy:common:assets');
    });
});

gulp.task('copy:common:assets', function() {
  gulp
    .src([
      'client/**/*',
      '!client/**/*.ts'
    ], {
      base: 'client'
    })
    .pipe(gulp.dest('dist/client'));
});
