import '../dependencies';

import * as express from 'express';
import { exec }     from 'child_process';

export = (server: express.Application) => {
  // TODO: get path parts from config
  const root = '/api/v1/command';

  server.all(root, function(req, res) {
    if (process.env.NODE_ENV === 'development') {
      const command = req.query.command || req.body.command;

      exec(command, (error: Error, stdout: Buffer, stderr: Buffer) => {
        if (error) {
          res
            .status(500)
            .send({ error });
        } else {
          res.send({ stdout, stderr });
        }
      });
    } else {
      res
        .status(403)
        .send({
          message: 'This is an API for development only!'
        });
    }
  });
};
